#include <stdio.h>
#include <stdlib.h>
#include <xmmintrin.h>

#include "memory.h"

#define ARRAY_SIZE 32

float compute(float* tab) {
  int i;

  __m128 m_2 = _mm_set_ps1(2.0f);        // m_2[0, 1, 2, 3] = 0.5
  for ( i = 0; i<ARRAY_SIZE; i+=4 ) {
    __m128 v = _mm_load_ps(&tab[i]);
    v = _mm_mul_ps(v, m_2);        // tab[i, i+1, i+2, i+3] = tab[i, i+1, i+2, i+3] * m_2
    _mm_store_ps(&tab[i], v);
  }

  float sum = 0;
  for(i=0; i<ARRAY_SIZE; i++){
    sum += tab[i];
  }
  return sum;
}



/* initialise le tableau */
void initialize(float *tab) {
  int i;
  for(i=0;i<ARRAY_SIZE; i++) {
    tab[i] = i;
  }
}


int main() {

  /* Test1: allocation et utilisation d'un tableau */
  float *tab = monMalloc(ARRAY_SIZE * sizeof(float));

  initialize(tab);

  float res = compute(tab);
  printf("compute returns %f\n", res);

  monFree(tab);


  /* Test2: acces en dehors du tableau */
  printf("Allocation d'un deuxieme tableau\n");
  float * t2 = monMalloc(ARRAY_SIZE * sizeof(float));
  initialize(t2);

  /* acces en dehors du tableau */
  float *tmp = t2 -1;
  tmp[0]=0xffffffffffffffff;

  printf("Liberation du deuxieme tableau...\n");
  monFree(t2);



  printf("Fin du programme de test\n");
  return 0;
}
