#include <sys/time.h>
#include <time.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include "stencil.h"

double *cur_step;
double *next_step;

/* initialize matrixes */
void init() {
  int i, j;

  cur_step = malloc(sizeof(double) * N * N);
  next_step = malloc(sizeof(double) * N * N);

  srand(time(NULL));
  for(i=0; i<N; i++) {
    for(j=0; j<N; j++) {
      GET(cur_step, i, j) = 0;
      GET(next_step, i, j) = 0;
    }
  }

#if 1
  /* create one point in the middle of the matrix */
  int posx = N/2;
  int posy = N/2;
#else
  /* create one random point */
  int posx = (N/4)+ (rand()%(N/2));
  int posy = (N/4)+ (rand()%(N/2));
#endif

  GET(cur_step, posx, posy) = N*10000;
}

void compute(int i_min, int i_max, int j_min, int j_max, double *src, double *dest)
{
  int i, j;

  for(i=i_min; i< i_max; i++) {
    for(j=j_min; j< j_max; j++) {
      GET(dest, i, j) = (GET(src, i-1, j) + GET(src, i+1, j) +
			 GET(src, i, j-1) + GET(src, i, j+1) +
			 GET(src, i, j)) / 5;
    }
  }
}


int main(int argc, char**argv) {

  struct timeval t1, t2;

  printf("Initialization (problem size: %d)\n", N);
  init();

  printf("Start computing (%d steps)\n", NB_STEPS);

  GET_TIME(t1);
  int i;

  for(i=0; i< NB_STEPS; i++) {
    printf("STEP %d...\n", i);
    compute(1, N-1, 1, N-1, cur_step, next_step);

    /* echange cur_step and next_step */
    double *tmp = cur_step;
    cur_step = next_step;
    next_step = tmp;

    print_matrix(cur_step);
    sleep(1);
  }

  GET_TIME(t2);

  double total_time = TIME_DIFF(t1, t2);
  printf("%d steps in %lf sec (%lf sec/step)\n",
	 NB_STEPS, total_time, total_time/NB_STEPS);

  return 0;
}
