#include <stdio.h>
#include "stencil.h"

void compute_boundaries(int *i_min, int *i_max, int *j_min, int *j_max, int nb_threads, int my_id) {

  *i_min = (my_id * (N/nb_threads));
  *i_max = ((my_id+1) * (N/nb_threads));

  if(*i_min == 0)
    (*i_min) ++;

  if(my_id == nb_threads-1)
    *i_max = N-1;

  *j_min = 1;
  *j_max = N-1;
}


/* very hot (red) */
#define VERY_HOT  "\x1B[31m"
/* hot (magenta) */
#define HOT  "\x1B[35m"
/* cold (yellow) */
#define COLD  "\x1B[33m"
/* very cold (white) */
#define VERY_COLD  "\x1B[0m"


void print_matrix(double* matrix) {
  printf("\x1B[2J");		/* clear screen */

  int i, j;

  for(i=1; i<N-1; i++) {
    for(j=1; j<N-1; j++) {
      if(GET(matrix, i, j) > 1000)
	printf("%s@", VERY_HOT);
      else if(GET(matrix, i, j) > 100)
	printf("%s@", HOT);
      else if(GET(matrix, i, j) > 10)
	printf("%s@", COLD);
      else
	printf("%s@", VERY_COLD);
    }
    printf("%s\n", VERY_COLD);
  }
}
